/* PowerPC asm definitions for GNU C.  */
/* Under winnt, 1) gas supports the following as names and 2) in particular
   defining "toc" breaks the FUNC_START macro as ".toc" becomes ".2" */

#if !defined(__WINNT__)
#define r0	0
#define sp	1
#define toc	2
#define r2	2
#define r3	3
#define r4	4
#define r5	5
#define r6	6
#define r7	7
#define r8	8
#define r9	9
#define r10	10
#define r11	11
#define r12	12
#define r13	13
#define r14	14
#define r15	15
#define r16	16
#define r17	17
#define r18	18
#define r19     19
#define r20	20
#define r21	21
#define r22	22
#define r23	23
#define r24	24
#define r25	25
#define r26	26
#define r27	27
#define r28	28
#define r29	29
#define r30	30
#define r31	31

#define cr0	0
#define cr1	1
#define cr2	2
#define cr3	3
#define cr4	4
#define cr5	5
#define cr6	6
#define cr7	7

#define f0	0
#define f1	1
#define f2	2
#define f3	3
#define f4	4
#define f5	5
#define f6	6
#define f7	7
#define f8	8
#define f9	9
#define f10	10
#define f11	11
#define f12	12
#define f13	13
#define f14	14
#define f15	15
#define f16	16
#define f17	17
#define f18	18
#define f19     19
#define f20	20
#define f21	21
#define f22	22
#define f23	23
#define f24	24
#define f25	25
#define f26	26
#define f27	27
#define f28	28
#define f29	29
#define f30	30
#define f31	31
#endif


#define C0      0
#define XER     1
#define LR      8     /* Link Register */
#define CTR     9     /* Counter Register */
#define DSISR   18    /* Cause of Data Access and Alignment Exceptions */
#define DAR     19    /* Data Address Register */
#define DEC_R   22    /* Decrementer Register */
#define SDR1    25    /* Page Table Format Register */
#define SRR0    26    /* Save/Restore Register 0 */
#define SRR1    27    /* Save/Restore Register 1 */
#define EAR      282   /* External Address Register */
#define PVR      287   /* Processor Version Register */
                          
#define SPRG0      272   /* Special Purpose Register General 0 */
#define SPRG1      273   /* Special Purpose Register General 1 */
#define SPRG2      274   /* Special Purpose Register General 2 */
#define SPRG3      275   /* Special Purpose Register General 3 */
                          
#define TBL_W      284   /* Time Base Write Register Lower */
#define TBU_W      285   /* Time Base Write Register Upper */
#define TBL_R      284   /* Time Base Read Register Lower */
#define TBU_R      285   /* Time Base Read Register Upper */
#define IBAT0U      528   /* Instruction BAT Register Upper 0 */
#define IBAT0L      529   /* Instruction BAT Register Lower 0 */
#define IBAT1U      530   /* Instruction BAT Register Upper 1 */
#define IBAT1L      531   /* Instruction BAT Register Lower 1 */
#define IBAT2U      532   /* Instruction BAT Register Upper 2 */
#define IBAT2L      533   /* Instruction BAT Register Lower 2 */
#define IBAT3U      534   /* Instruction BAT Register Upper 3 */
#define IBAT3L      535   /* Instruction BAT Register Lower 3 */
#define DBAT0U      536   /* Data BAT Register Upper 0 */
#define DBAT0L      537   /* Data BAT Register Lower 0 */
#define DBAT1U      538   /* Data BAT Register Upper 1 */
#define DBAT1L      539   /* Data BAT Register Lower 1 */
#define DBAT2U      540   /* Data BAT Register Upper 2 */
#define DBAT2L      541   /* Data BAT Register Lower 2 */
#define DBAT3U      542   /* Data BAT Register Upper 3 */
#define DBAT3L      543   /* Data BAT Register Lower 3 */
                         
#define DMISS      976   /* Data TLB Miss Register */
#define DCMP      977   /* Data PTE Compare Register */
#define HASH1      978   /* Primary Hash Address Register */
#define HASH2      979   /* Secondary Hash Address Register */
#define IMISS      980   /* Instruction TLB Miss Register */
#define ICMP      981   /* Instruction PTE Compare Register */
#define RPA      982   /* Required Physical Address Register */
#define HID0      1008  /* Hardware Implementation Register 0                          */
#define HID1      1009  /* Hardware Implementation Register 1                          */
 
/*---------------------------------------------------------------------------- */
/* Register Offset Definitions. All these values are offsets from the  */
/* Internal Memory Map Register (IMMR) base pointer + 0x10000. The base value  */
/* is determined by the ISB bits in the Hard Reset Configuration Word. See the  */
/* reset section of the user's manual. For a complete set of all the IMMR  */
/* registers, refer to the MPC8260 Users Manual. As an additional note, only  */
/* those register values used in this example are listed below. Therefore this  */
/* list does not comprise all possible Internal Memory Mapped Registers. */
/*---------------------------------------------------------------------------- */

#define SIUMCR      0x00000000   /* SIU Module Configuration Register */
#define SYPCR      0x00000004   /* System Protection Control Register */
#define BCR      0x00000024   /* Bus Configuration Register */
#define PPC_ACR      0x00000028   /* 60x Bus Arbiter Configuration Register */
#define PPC_ALRH      0x0000002C   /* 60x Bus Arbitration-Level[High] Register */
#define TESCR1      0x00000040   /* 60x Bus Transfer Error Status and */
/* Control Register 1 */

#define LTESCR1      0x00000048   /* Local Bus Transfer Error Status and */
/* Control Register 1 */

 
#define SCCR      0x00000C80   /* System Clock Control Register */
#define BR0      0x00000100   /* Base Register Bank 0 */
#define OR0      0x00000104   /* Option Register Bank 0 */
#define BR1      0x00000108   /* Base Register Bank 1 */
#define OR1      0x0000010C   /* Option Register Bank 1 */
#define BR2      0x00000110   /* Base Register Bank 2 */
#define OR2      0x00000114   /* Option Regiser Bank 2 */
#define BR3      0x00000118   /* Base Register Bank 3 */
#define OR3      0x0000011C   /* Option Register Bank 3 */
#define BR4      0x00000120   /* Base Register Bank 4 */
#define OR4      0x00000124   /* Option Register Bank 4 */
#define MPTPR      0x00000184   /* Memory Periodic Timer Prescaler Register */
#define PSDMR      0x00000190   /* PowerPC Bus SDRAM Machine Mode Register */
#define LSDMR      0x00000194   /* Local Bus SDRAM Machine Mode Register */
#define PSRT      0x0000019C   /* 60x Bus Assigned SDRAM Refresh Timer */
#define LSRT      0x000001A4   /* Local Bus Assigned SDRAM Refresh Timer */
#define IMMR      0x000001A8   /* Internal I/O base register offset */

/*
 * Macros to glue together two tokens.
 */

#ifdef __STDC__
#define XGLUE(a,b) a##b
#else
#define XGLUE(a,b) a/**/b
#endif

#define GLUE(a,b) XGLUE(a,b)

/*
 * Macros to begin and end a function written in assembler.  If -mcall-aixdesc
 * or -mcall-nt, create a function descriptor with the given name, and create
 * the real function with one or two leading periods respectively.
 */

#ifdef _RELOCATABLE
#define DESC_SECTION ".got2"
#else
#define DESC_SECTION ".got1"
#endif

#if defined(_CALL_AIXDESC)
#define FUNC_NAME(name) GLUE(.,name)
#define FUNC_START(name) \
	.section DESC_SECTION,"aw"; \
name: \
	.long GLUE(.,name); \
	.long _GLOBAL_OFFSET_TABLE_; \
	.long 0; \
	.previous; \
	.type GLUE(.,name),@function; \
	.globl name; \
	.globl GLUE(.,name); \
GLUE(.,name):

#define FUNC_END(name) \
GLUE(.L,name): \
	.size GLUE(.,name),GLUE(.L,name)-GLUE(.,name)

#elif defined(__WINNT__)
#define FUNC_NAME(name) GLUE(..,name)
#define FUNC_START(name) \
	.pdata; \
	.align 2; \
	.ualong GLUE(..,name),GLUE(name,.e),0,0,GLUE(..,name); \
	.reldata; \
name: \
	.ualong GLUE(..,name),.toc; \
	.section .text; \
	.globl name; \
	.globl GLUE(..,name); \
GLUE(..,name):

#define FUNC_END(name) \
GLUE(name,.e): ; \
GLUE(FE_MOT_RESVD..,name):

#elif defined(_CALL_NT)
#define FUNC_NAME(name) GLUE(..,name)
#define FUNC_START(name) \
	.section DESC_SECTION,"aw"; \
name: \
	.long GLUE(..,name); \
	.long _GLOBAL_OFFSET_TABLE_; \
	.previous; \
	.type GLUE(..,name),@function; \
	.globl name; \
	.globl GLUE(..,name); \
GLUE(..,name):

#define FUNC_END(name) \
GLUE(.L,name): \
	.size GLUE(..,name),GLUE(.L,name)-GLUE(..,name)

#else
#define FUNC_NAME(name) name
#define FUNC_START(name) \
	.type name,@function; \
	.globl name; \
name:

#define FUNC_END(name) \
GLUE(.L,name): \
	.size name,GLUE(.L,name)-name
#endif

